#coding: utf-8

import gtk

class prefsDialog():
	def __init__(self, parent, settings, obj):
		self.dialog = gtk.Dialog(_("PowerTotem Preferences"), parent,\
		gtk.DIALOG_DESTROY_WITH_PARENT,\
		(gtk.STOCK_CLOSE, gtk.RESPONSE_ACCEPT))

		TopHBox = gtk.HBox()

		TopEvent = gtk.EventBox()
		TopEvent.modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color(65535, 65535, 65535))

		Image = gtk.image_new_from_icon_name("totem", gtk.ICON_SIZE_DIALOG)
		TopHBox.pack_start(Image, False, False, 0)

		Label = gtk.Label(_("<big><big>Power Totem</big></big>\n<small>Preferences</small>"))
		Label.set_use_markup(True)
		Label.set_alignment(0.1, 0.5)
		TopHBox.add(Label)


		Frame = gtk.Frame(None)
		Frame.set_shadow_type(gtk.SHADOW_IN)
		Frame.set_border_width(10)


		MainVBox = gtk.VBox(False, 5)

		SubCheck = gtk.CheckButton(_("Show subtitles"))
		MainVBox.add(SubCheck)
		TrayCheck = gtk.CheckButton(_("Show tray icon"))
		MainVBox.add(TrayCheck)
		ToolbarCheck = gtk.CheckButton(_("Show main toolbar"))
		MainVBox.add(ToolbarCheck)
		MenuCheck = gtk.CheckButton(_("Show main menu bar"))
		MainVBox.add(MenuCheck)
		SaveCheck = gtk.CheckButton(_("Save and restore position"))
		MainVBox.add(SaveCheck)
		#NextCheck = gtk.CheckButton(_("Automatically load next part"))
		#MainVBox.add(NextCheck)

		FPSHBox = gtk.HBox()
		FPSLabel = gtk.Label(_("FPS (for MicroDVD subtitles):"))
		FPSLabel.set_alignment(0, 0.5)
		FPSSpin = gtk.SpinButton(None, 1, 3)
		FPSSpin.set_increments(0.1, 1)
		FPSSpin.set_size_request(90, -1)
		FPSSpin.set_range(0, 40)

		FPSHBox.pack_start(FPSLabel, True, True, 0)
		FPSHBox.pack_start(FPSSpin, False, False, 0)
		MainVBox.add(FPSHBox)


		LinesHBox = gtk.HBox()
		LinesLabel = gtk.Label(_("Visible subtitle lines:"))
		LinesLabel.set_alignment(0, 0.5)
		LinesSpin = gtk.SpinButton(None, 1, 0)
		LinesSpin.set_size_request(90, -1)
		LinesSpin.set_increments(1, 5)
		LinesSpin.set_range(0, 10)

		LinesHBox.pack_start(LinesLabel, True, True, 0)
		LinesHBox.pack_start(LinesSpin, False, False, 0)
		MainVBox.pack_start(LinesHBox, True, True, 0)




		Alignment = gtk.Alignment(0, 0, 1, 1)
		Alignment.set_border_width(5)
		Alignment.add(MainVBox)
		Frame.add(Alignment)

		BottomLabel = gtk.Label(_("<small>These settings apply only when PowerTotem plugin is enabled.\n(c) 2008 by Tomasz Sałaciński &lt;tsalacinski@gmail.com&gt;</small>"))
		BottomLabel.set_use_markup(True)
		BottomLabel.set_alignment(0.5, 0.5)
		BottomLabel.set_size_request(-1, 50)

		TopEvent.add(TopHBox)
		self.dialog.vbox.pack_start(TopEvent, False, False, 0)
		self.dialog.vbox.pack_start(Frame, True, True, 0)
		self.dialog.vbox.add(BottomLabel)

		



		self.dialog.show_all()
		self.dialog.set_position(gtk.WIN_POS_CENTER_ON_PARENT)



		self.dialog.set_size_request(400, 370)
		self.dialog.set_resizable(False)


		

		# Setting values

		if settings.get_setting('menu_visible') == 'true':
			MenuCheck.set_active(True)
		else:
			MenuCheck.set_active(False)

		if settings.get_setting('toolbar_visible') == 'true':
			ToolbarCheck.set_active(True)
		else:
			ToolbarCheck.set_active(False)

		if settings.get_setting('tray_icon') == 'true':
			TrayCheck.set_active(True)
		else:
			TrayCheck.set_active(False)

		if settings.get_setting('subtitles') == 'true':
			SubCheck.set_active(True)
		else:
			SubCheck.set_active(False)

#		if settings.get_setting('next_load') == 'true':
#			NextCheck.set_active(True)
#		else:
#			NextCheck.set_active(False)

		if settings.get_setting('save_position') == 'true':
			SaveCheck.set_active(True)
		else:
			SaveCheck.set_active(False)

		FPSSpin.set_value(float(settings.get_setting('fallback_fps')))
		LinesSpin.set_value(float(settings.get_setting('sub_lines')))




#		print >> config, "menu_visible=true"
#		print >> config, "toolbar_visible=true"
#		print >> config, "tray_icon=true"
#		print >> config, "subtitles=true"
#		print >> config, "next_load=true"
#		print >> config, "save_position=true"
#		print >> config, "sub_lines=2"
#		print >> config, "fallback_fps=23.976"


		self.dialog.run()

		if MenuCheck.get_active():
			settings.save_setting('menu_visible', 'true')
		else:
			settings.save_setting('menu_visible', 'false')

		if ToolbarCheck.get_active():
			settings.save_setting('toolbar_visible', 'true')
		else:
			settings.save_setting('toolbar_visible', 'false')

		if TrayCheck.get_active():
			settings.save_setting('tray_icon', 'true')
		else:
			settings.save_setting('tray_icon', 'false')

		if SubCheck.get_active():
			settings.save_setting('subtitles', 'true')
		else:
			settings.save_setting('subtitles', 'false')

#		if NextCheck.get_active():
#			settings.save_setting('next_load', 'true')
#		else:
#			settings.save_setting('next_load', 'false')

		if SaveCheck.get_active():
			settings.save_setting('save_position', 'true')
		else:
			settings.save_setting('save_position', 'false')

		settings.save_setting('fallback_fps', str(FPSSpin.get_value()))
		settings.save_setting('sub_lines', str(int(LinesSpin.get_value())))


		obj.set_show_toolbar(ToolbarCheck.get_active())
		obj.set_show_status_icon(TrayCheck.get_active())
		obj.set_show_sub_label(SubCheck.get_active())
		obj.set_show_menu(MenuCheck.get_active())

		self.dialog.destroy()

		
