import os, os.path

class settings:
	def __init__(self):
		self.config_path = os.getenv("HOME") + "/.gnome2/powertotem"
		if os.path.exists(self.config_path):
			self.config = file(self.config_path, "r")
		else:
			self.create_config_file(self.config_path)
			self.config = file(self.config_path, "r")

		self.reload_contents()

		self.config.close()

	def reload_contents(self):
		self.config_contents = []
		config_file = file(self.config_path, "r")
		for line in config_file:
			self.config_contents.append(line)

	def create_config_file(self, config_path):
		config = file(config_path, "w")

		print >> config, "menu_visible=true"
		print >> config, "toolbar_visible=true"
		print >> config, "tray_icon=true"
		print >> config, "subtitles=true"
		print >> config, "next_load=true"
		print >> config, "save_position=true"
		print >> config, "sub_lines=2"
		print >> config, "fallback_fps=23.976"

		config.close()
		del config

	def get_setting(self, setting_name):
		for line in self.config_contents:
			if line.split('=')[0] == setting_name:
				return line.split('=')[1].split("\n")[0]

		return None

	def save_setting(self, setting_name, value):
		new_file = []
		for line in self.config_contents:
			if line.split('=')[0] == setting_name:
				new_file.append("%s=%s" % (setting_name, value))
			else:
				new_file.append(line.split('\n')[0])

		conf = file(self.config_path, "w")

		for line in new_file:
			print >> conf, line

		conf.close()
		del conf

		self.reload_contents()

	def save_movie_pos(self, path, position):
		conf = file(self.config_path, "r")


		newfile = []
		found = False

		for line in conf:
			newline = line
			if line.split('=')[0] == 'filepath-' + path:
				newline = 'filepath-' + path + '=' + str(position)
				found = True

			newfile.append(newline)


		if not found:
			to_append = 'filepath-' + path + '=' + str(position)
			newfile.append(to_append)




		conf.close()
		conf = file(self.config_path, "w")

		for line in newfile:
			print >> conf, line.strip()
			

		conf.close()

	def get_movie_pos(self, path):
		conf = file(self.config_path, "r")
		for line in conf:
			if line.split('=')[0] == 'filepath-' + path:
				conf.close()
				return line.split('=')[1].split("\n")[0]

		conf.close()
		return None
