#coding: utf-8
import gconf
import re
import pango_decode
import os, os.path

def get_gconf_value(value):
	full_value = '/apps/totem/' + value
	client = gconf.client_get_default()
	return client.get_value(full_value)

def sub_update(wid, sub_change_func, status_label, main_window, settings_object, totem, obj, is_last):
	sub_text = ""

	if obj.EverySec == True:
		obj.EverySec = False
		return
	else:
		obj.EverySec = True

	if obj.NotRestore == False and obj.Restored == False and not settings_object.get_movie_pos(totem.props.current_mrl) == None and settings_object.get_setting('save_position') == 'true':

		totem.action_seek_time(int(settings_object.get_movie_pos(totem.props.current_mrl)) * 1000)
		obj.Restored = True

	if settings_object.get_setting('save_position') == 'false':
		obj.Restored = True

	obj.NotRestore = False




	if is_last and obj.shut_active:
		if int(wid.get_value()) > 65000:
			obj.PreviousLast = True
		if int(wid.get_value()) == 0 and obj.PreviousLast == True:
			os.system('xset dpms force off')
			obj.PreviousLast = False

	if settings_object.get_setting('save_position') == 'true':
		settings_object.save_movie_pos(totem.props.current_mrl, get_pos_in_seconds(status_label.get_text()))

	title = main_window.get_title()
	if not title == 'minimized_totem' and not title.split(' ')[0] == 'PowerTotem':
		main_window.set_title("PowerTotem - %s" % title)

	if not settings_object.get_setting('subtitles') == 'true':
		return

	if not title == 'minimized_totem':
		sub_file = title
	else:
		return


	
	obj.set_show_border()

	if not obj.OwnSubs:
		sub_path = totem.props.current_mrl
	else:
		sub_path = obj.OwnSubName

	sub_path = check_encoding(sub_path)

	splitted = sub_path.split('/')

	app = ''

	for line in splitted:
		if not line == 'file:' and not line == '':
			app = app + "/" + line


	subfile_name = os.path.split(app)[-1].split('.')[0] + '.txt'


	if not os.path.exists(os.path.split(app)[0] + '/' + subfile_name):
		sub_change_func('powertotem-disable-text')
		return

	filename = os.path.split(app)


	encoding = get_gconf_value('subtitle_encoding')

	os.system('iconv -f %s -t UTF-8 \'%s\' -o /tmp/powertotem-temp' % (encoding, os.path.split(app)[0] + '/' + subfile_name))

	
	subfile_name = '/tmp/powertotem-temp'
	
	try:
		handler = file(subfile_name, 'r')
	except:
		return
	to_read = handler.read()
	handler.close()

	for line in to_read:
		sub_text += line



	sub = sub_decode(get_pos_in_seconds(status_label.get_text()), sub_text, settings_object)

	sublines = int(settings_object.get_setting('sub_lines'))

	slashes = ''

	for x in range(0, sublines):
		slashes += 'A\n'

	if sub == None:
		sub = "<span color=\"#000\">%s</span>" % slashes
		sub_change_func(sub)
		return
	sub_change_func(pango_decode.sub_enable_pango(sub, sublines))

def get_pos_in_seconds(text):

	text = text.split("/")[0]

	if len(text.split(":")) == 2:
		show_type = 1
		data = re.search("(\d*):(\d*)", text)
	else:
		show_type = 2
		data = re.search("(\d*):(\d*):(\d*)", text)





	hours = 0
	minutes = 0
	seconds = 0

	if show_type == 1:
		minutes = int(data.group(1))
		seconds = int(data.group(2))

	elif show_type == 2:
		hours = int(data.group(1))
		minutes = int(data.group(2))
		seconds = int(data.group(3))



	total = hours * 3600 + minutes * 60 + seconds



	return total


def sub_decode(position, text, settings_object):
	sub_type = detect_type(text, settings_object)

	if sub_type[0] == 'microdvd':
		return decode_microdvd(text, position, sub_type[1])


def detect_type(text, settings_object):
	firstline = text.split('\n')[0]
	if not re.compile("\{\d*\}\{\d*\}*").match(firstline, 0) == None:
		standard_fps = float(settings_object.get_setting('fallback_fps'))
		if firstline == '{1}{1}25.000':
			standard_fps = 25
		return ['microdvd', standard_fps]

def decode_microdvd(text, position, frames):
	for line in text.split('\n'):
		if line == "": continue
		data = re.search("\{(\d*)\}\{(\d*)\}(.*)", line)
		first_frame = int(data.group(1))
		last_frame = int(data.group(2))
		content = str(data.group(3))

		position_frames = position * frames;

		if (first_frame - 10) < position_frames and (last_frame - 10) > position_frames:
			return content.replace("|", "\n")



def check_encoding(path):
	while True:
		position = path.find("%")
		if position == -1: break
		value = chr(int('0x' + path[position+1:position+3], 16))
		path = path.replace(path[position:position+3], value)

	return path
